/*
* ========== Copyright Header Begin ==========================================
*
* Hypervisor Software File: aslex.c
* 
* Copyright (c) 2006 Sun Microsystems, Inc. All Rights Reserved.
* 
*  - Do no alter or remove copyright notices
* 
*  - Redistribution and use of this software in source and binary forms, with 
*    or without modification, are permitted provided that the following 
*    conditions are met: 
* 
*  - Redistribution of source code must retain the above copyright notice, 
*    this list of conditions and the following disclaimer.
* 
*  - Redistribution in binary form must reproduce the above copyright notice,
*    this list of conditions and the following disclaimer in the
*    documentation and/or other materials provided with the distribution. 
* 
*    Neither the name of Sun Microsystems, Inc. or the names of contributors 
* may be used to endorse or promote products derived from this software 
* without specific prior written permission. 
* 
*     This software is provided "AS IS," without a warranty of any kind. 
* ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, 
* INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A 
* PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN 
* MICROSYSTEMS, INC. ("SUN") AND ITS LICENSORS SHALL NOT BE LIABLE FOR 
* ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR 
* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN 
* OR ITS LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR 
* FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE 
* DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, 
* ARISING OUT OF THE USE OF OR INABILITY TO USE THIS SOFTWARE, EVEN IF 
* SUN HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* 
* You acknowledge that this software is not designed, licensed or
* intended for use in the design, construction, operation or maintenance of
* any nuclear facility. 
* 
* ========== Copyright Header End ============================================
*/
#line 2 "aslex.c"

#line 4 "aslex.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 31
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined __STDC_VERSION__ && __STDC_VERSION__ >= 199901L
#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;
#endif /* ! C99 */

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#if __STDC__

#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE aslexrestart(aslexin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#define YY_BUF_SIZE 16384
#endif

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

extern int aslexleng;

extern FILE *aslexin, *aslexout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    #define YY_LESS_LINENO(n)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up aslextext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up aslextext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef unsigned int yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via aslexrestart()), so that the user can continue scanning by
	 * just pointing aslexin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when aslextext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int aslexleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 1;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow aslexwrap()'s to do buffer switches
 * instead of setting up a fresh aslexin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void aslexrestart (FILE *input_file  );
void aslex_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE aslex_create_buffer (FILE *file,int size  );
void aslex_delete_buffer (YY_BUFFER_STATE b  );
void aslex_flush_buffer (YY_BUFFER_STATE b  );
void aslexpush_buffer_state (YY_BUFFER_STATE new_buffer  );
void aslexpop_buffer_state (void );

static void aslexensure_buffer_stack (void );
static void aslex_load_buffer_state (void );
static void aslex_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER aslex_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE aslex_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE aslex_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE aslex_scan_bytes (yyconst char *bytes,int len  );

void *aslexalloc (yy_size_t  );
void *aslexrealloc (void *,yy_size_t  );
void aslexfree (void *  );

#define yy_new_buffer aslex_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        aslexensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            aslex_create_buffer(aslexin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        aslexensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            aslex_create_buffer(aslexin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

typedef unsigned char YY_CHAR;

FILE *aslexin = (FILE *) 0, *aslexout = (FILE *) 0;

typedef int yy_state_type;

extern int aslexlineno;

int aslexlineno = 1;

extern char *aslextext;
#define yytext_ptr aslextext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up aslextext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	aslexleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 36
#define YY_END_OF_BUFFER 37
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[99] =
    {   0,
        0,    0,    0,    0,   11,   11,   37,   35,   34,   12,
       35,    7,   35,   35,   35,   33,   30,   30,   30,   35,
       35,   35,   33,   30,   35,   30,   30,    5,    4,    5,
       11,    9,    8,   11,   34,    0,    1,   29,    3,    0,
       33,   30,   30,   30,    0,    2,    0,   28,    0,   33,
       30,   30,   30,    6,   11,   10,   29,   32,   31,   21,
       19,   30,   30,   20,   22,   27,   23,   26,   24,   25,
       32,   31,   21,   19,   30,   30,   20,   22,   27,   23,
       26,   24,   25,   31,   13,   15,   17,   14,   16,   18,
       31,   13,   15,   17,   14,   16,   18,    0

    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    4,    5,    6,    1,    7,    1,    1,    1,
        1,    8,    1,    1,    1,    9,   10,   11,   12,   12,
       12,   12,   12,   12,   12,   12,   12,   13,    1,    1,
        1,    1,    1,    1,   14,   14,   14,   14,   14,   14,
       15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
       15,   15,   15,   15,   15,   15,   15,   15,   15,   15,
        1,   16,    1,    1,   17,    1,   18,   19,   18,   20,

       18,   18,   21,   22,   21,   21,   21,   23,   21,   24,
       21,   21,   21,   21,   25,   26,   27,   21,   28,   29,
       21,   21,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[30] =
    {   0,
        1,    1,    1,    1,    2,    1,    1,    1,    1,    1,
        3,    3,    4,    3,    5,    1,    5,    6,    6,    6,
        7,    7,    7,    7,    7,    7,    7,    7,    7
    } ;

static yyconst flex_int16_t yy_base[110] =
    {   0,
        0,   29,   56,   57,   58,   63,  225,  226,  222,  226,
      220,  226,    0,  214,  192,   58,    0,  200,  192,  214,
        0,   49,   60,  201,  200,   62,   54,  226,  226,  196,
        0,    0,  226,  191,  182,  153,  226,   65,  226,  144,
       72,    0,   65,   76,  151,  226,  132,  226,   95,   75,
      123,  103,  120,  226,    0,  226,   90,  226,    0,    0,
        0,   98,  103,    0,    0,    0,    0,    0,    0,    0,
      122,  139,  121,  116,  124,  119,  111,  108,  106,  105,
       99,   98,   97,    0,    0,    0,    0,    0,    0,    0,
        0,   90,   86,   84,   80,   78,   68,  226,  159,  166,

      173,  175,  180,  187,  192,  197,  204,  209,  213
    } ;

static yyconst flex_int16_t yy_def[110] =
    {   0,
       98,   98,   99,   99,  100,  100,   98,   98,   98,   98,
      101,   98,  102,   98,   98,   98,  103,  103,  103,  104,
      105,  105,  105,  106,  105,  106,  106,   98,   98,   98,
      107,  107,   98,  107,   98,  101,   98,  102,   98,  108,
       98,  103,  103,  103,  104,   98,  105,   98,  105,  105,
      106,  106,  106,   98,  107,   98,   98,   98,  109,  103,
      103,  103,  103,  103,  103,  103,  103,  103,  103,  103,
      105,   49,  106,  106,  106,   75,  106,  106,  106,  106,
      106,  106,  106,  109,  103,  103,  103,  103,  103,  103,
       72,  106,  106,  106,  106,  106,  106,    0,   98,   98,

       98,   98,   98,   98,   98,   98,   98,   98,   98
    } ;

static yyconst flex_int16_t yy_nxt[256] =
    {   0,
        8,    9,   10,   11,   12,    8,   13,    8,    8,   14,
       15,   16,    8,   17,   17,    8,    8,   17,   17,   17,
       17,   17,   18,   17,   19,   17,   17,   17,   17,    8,
        9,   10,   11,   12,   20,   13,    8,   21,   14,   22,
       23,    8,   24,   24,    8,   25,   24,   24,   24,   24,
       24,   26,   24,   27,   24,   24,   24,   24,   29,   29,
       32,   48,   33,   30,   30,   32,   48,   33,   41,   41,
       50,   50,   48,   34,   48,   57,   57,   49,   34,   53,
       48,   52,   41,   41,   60,   50,   50,   48,   61,   62,
       48,   63,   48,   64,   65,   66,   48,   67,   48,   68,

       57,   57,   48,   69,   70,   71,   72,   48,   72,   48,
       48,   48,   72,   72,   72,   48,   85,   48,   48,   86,
       48,   88,   73,   48,   89,   87,   74,   75,   48,   76,
       90,   77,   48,   48,   48,   48,   48,   95,   78,   79,
       96,   80,   92,   81,   48,   93,   97,   82,   83,   91,
       91,   94,   91,   46,   58,   37,   91,   91,   91,   28,
       28,   28,   28,   28,   28,   28,   31,   31,   31,   31,
       31,   31,   31,   36,   36,   36,   36,   36,   36,   36,
       38,   38,   42,   35,   42,   42,   42,   45,   45,   45,
       45,   45,   45,   45,   47,   56,   47,   47,   47,   51,

       51,   51,   51,   51,   55,   54,   55,   55,   55,   55,
       55,   59,   48,   48,   59,   84,   46,   44,   84,   43,
       40,   39,   37,   35,   98,    7,   98,   98,   98,   98,
       98,   98,   98,   98,   98,   98,   98,   98,   98,   98,
       98,   98,   98,   98,   98,   98,   98,   98,   98,   98,
       98,   98,   98,   98,   98
    } ;

static yyconst flex_int16_t yy_chk[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    3,    4,
        5,   22,    5,    3,    4,    6,   27,    6,   16,   16,
       23,   23,   23,    5,   26,   38,   38,   22,    6,   27,
       97,   26,   41,   41,   43,   50,   50,   50,   43,   43,
       96,   43,   95,   43,   44,   44,   94,   44,   93,   44,

       57,   57,   92,   44,   44,   49,   49,   49,   49,   83,
       82,   81,   49,   49,   49,   52,   62,   80,   79,   62,
       78,   63,   52,   77,   63,   62,   52,   52,   74,   52,
       63,   52,   53,   73,   71,   51,   75,   76,   53,   53,
       76,   53,   75,   53,   47,   75,   76,   53,   53,   72,
       72,   75,   72,   45,   40,   36,   72,   72,   72,   99,
       99,   99,   99,   99,   99,   99,  100,  100,  100,  100,
      100,  100,  100,  101,  101,  101,  101,  101,  101,  101,
      102,  102,  103,   35,  103,  103,  103,  104,  104,  104,
      104,  104,  104,  104,  105,   34,  105,  105,  105,  106,

      106,  106,  106,  106,  107,   30,  107,  107,  107,  107,
      107,  108,   25,   24,  108,  109,   20,   19,  109,   18,
       15,   14,   11,    9,    7,   98,   98,   98,   98,   98,
       98,   98,   98,   98,   98,   98,   98,   98,   98,   98,
       98,   98,   98,   98,   98,   98,   98,   98,   98,   98,
       98,   98,   98,   98,   98
    } ;

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int aslex_flex_debug;
int aslex_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *aslextext;
#line 1 "aslex.l"
/*
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
#line 7 "aslex.l"

#pragma ident	"@(#)aslex.l	1.2	07/02/12 SMI"

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdarg.h>
#include <errno.h>
#include <sys/param.h>	/* for MAXPATHLEN */
#include <string.h>	/* for strchr & strdup */
#include <ctype.h>	/* for islower / toupper */

#include <assert.h>

#include "basics.h"
#include "internal.h"
#include "parser.h"


int aslexwrap();

bool_t flag_debug = false;

YYLTYPE yyloc;
yylval_t yylval;

int yy_line_num;

#define	UOP(_t, _size)	{ yylval.ldst.wordsize=(_size); yylval.ldst.signext=false; return (_t); }
#define	SOP(_t, _size)	{ yylval.ldst.wordsize=(_size); yylval.ldst.signext=true; return (_t); }

void validate_op(token_t tok, ldst_t *ldstinfop, char *namep);



#line 570 "aslex.c"

#define INITIAL 0
#define comment 1
#define string 2

/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int aslexwrap (void );
#else
extern int aslexwrap (void );
#endif
#endif

    static void yyunput (int c,char *buf_ptr  );
    
#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO (void) fwrite( aslextext, aslexleng, 1, aslexout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( aslexin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( aslexin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, aslexin))==0 && ferror(aslexin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(aslexin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int aslexlex (void);

#define YY_DECL int aslexlex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after aslextext and aslexleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( aslexleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(aslextext[aslexleng - 1] == '\n'); \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    
#line 45 "aslex.l"


#line 727 "aslex.c"

	if ( (yy_init) )
		{
		(yy_init) = 0;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! aslexin )
			aslexin = stdin;

		if ( ! aslexout )
			aslexout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			aslexensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				aslex_create_buffer(aslexin,YY_BUF_SIZE );
		}

		aslex_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of aslextext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 99 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 226 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(comment):
case YY_STATE_EOF(string):
#line 47 "aslex.l"
{
				return T_eof;
				}
	YY_BREAK
case 1:
*yy_cp = (yy_hold_char); /* undo effects of setting up aslextext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up aslextext again */
YY_RULE_SETUP
#line 51 "aslex.l"
{
				DBG(printf("comment: %s\n", aslextext););
				}
	YY_BREAK
case 2:
*yy_cp = (yy_hold_char); /* undo effects of setting up aslextext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up aslextext again */
YY_RULE_SETUP
#line 55 "aslex.l"
{
				DBG(printf("directive: %s\n", aslextext););
				}
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 59 "aslex.l"
{
				BEGIN(comment);
				DBG(printf("comment begin\n"););
				}
	YY_BREAK
case 4:
/* rule 4 can match eol */
YY_RULE_SETUP
#line 64 "aslex.l"
{
				yy_line_num++;
				}
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 68 "aslex.l"
/* swallow */
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 70 "aslex.l"
{
				BEGIN(INITIAL);
				DBG(printf("comment end\n"););
				}
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 75 "aslex.l"
{
				BEGIN(string);
				DBG(printf("string begin\n"););
				}
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 80 "aslex.l"
{
				BEGIN(INITIAL);
				DBG(printf("string end\n"););
				yylval.namep = NULL;	/* dont care for now */
				return T_string;
				}
	YY_BREAK
case 9:
/* rule 9 can match eol */
YY_RULE_SETUP
#line 87 "aslex.l"
{
				yy_line_num++;
				}
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 91 "aslex.l"
{ /* escaped quote is part of string */ }
	YY_BREAK
case 11:
/* rule 11 can match eol */
YY_RULE_SETUP
#line 93 "aslex.l"
{ /* swallow for now */ }
	YY_BREAK
case 12:
/* rule 12 can match eol */
YY_RULE_SETUP
#line 96 "aslex.l"
{
				yyloc.first_line =
					yyloc.last_line = ++yy_line_num;
				return T_nl;
				}
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 102 "aslex.l"
{ SOP(T_load, 1); }
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 104 "aslex.l"
{ UOP(T_load, 1); }
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 106 "aslex.l"
{ SOP(T_load, 2); }
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 108 "aslex.l"
{ UOP(T_load, 2); }
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 110 "aslex.l"
{ SOP(T_load, 4); }
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 112 "aslex.l"
{ UOP(T_load, 4); }
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 114 "aslex.l"
{ UOP(T_load, 8); }
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 116 "aslex.l"
{ UOP(T_load, 8); }
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 118 "aslex.l"
{ UOP(T_load, 16); }
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 120 "aslex.l"
{ UOP(T_store, 1); }
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 122 "aslex.l"
{ UOP(T_store, 2); }
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 124 "aslex.l"
{ UOP(T_store, 4); }
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 126 "aslex.l"
{ UOP(T_store, 8); }
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 128 "aslex.l"
{ UOP(T_store, 8); }
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 130 "aslex.l"
{ UOP(T_store, 16); }
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 132 "aslex.l"
{
				yylval.namep = strdup(aslextext);
				return T_labeldef; 
				}
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 137 "aslex.l"
{
				yylval.namep = strdup(aslextext);
				return T_register;
				}
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 142 "aslex.l"
{
				yylval.namep = strdup(aslextext);
				return T_name; 
				}
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 147 "aslex.l"
{
				uint64_t val;
				val = strtoull(aslextext, NULL, 16);
				yylval.val = val;
				return T_number;	
				}
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 154 "aslex.l"
{
				yylval.val = 0;
				return T_number;
				}
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 159 "aslex.l"
{
				uint64_t val;
				val = strtoull(aslextext, NULL, 10);
				yylval.val = val;
				return T_number;	
				}
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 167 "aslex.l"
{ /* swallow */ }
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 169 "aslex.l"
return aslextext[0] ;
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 171 "aslex.l"
ECHO;
	YY_BREAK
#line 1057 "aslex.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed aslexin at a new source and called
			 * aslexlex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = aslexin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( aslexwrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * aslextext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of aslexlex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = (yytext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			size_t num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					aslexrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			aslexrestart(aslexin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 99 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	register int yy_is_jam;
    	register char *yy_cp = (yy_c_buf_p);

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 99 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 98);

	return yy_is_jam ? 0 : yy_current_state;
}

    static void yyunput (int c, register char * yy_bp )
{
	register char *yy_cp;
    
    yy_cp = (yy_c_buf_p);

	/* undo effects of setting up aslextext */
	*yy_cp = (yy_hold_char);

	if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = (yy_n_chars) + 2;
		register char *dest = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[
					YY_CURRENT_BUFFER_LVALUE->yy_buf_size + 2];
		register char *source =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move];

		while ( source > YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars =
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_buf_size;

		if ( yy_cp < YY_CURRENT_BUFFER_LVALUE->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;

	(yytext_ptr) = yy_bp;
	(yy_hold_char) = *yy_cp;
	(yy_c_buf_p) = yy_cp;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					aslexrestart(aslexin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( aslexwrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve aslextext */
	(yy_hold_char) = *++(yy_c_buf_p);

	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void aslexrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        aslexensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            aslex_create_buffer(aslexin,YY_BUF_SIZE );
	}

	aslex_init_buffer(YY_CURRENT_BUFFER,input_file );
	aslex_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void aslex_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		aslexpop_buffer_state();
	 *		aslexpush_buffer_state(new_buffer);
     */
	aslexensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	aslex_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (aslexwrap()) processing, but the only time this flag
	 * is looked at is after aslexwrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void aslex_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	aslexin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE aslex_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) aslexalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in aslex_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) aslexalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in aslex_create_buffer()" );

	b->yy_is_our_buffer = 1;

	aslex_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with aslex_create_buffer()
 * 
 */
    void aslex_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		aslexfree((void *) b->yy_ch_buf  );

	aslexfree((void *) b  );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a aslexrestart() or at EOF.
 */
    static void aslex_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	aslex_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then aslex_init_buffer was _probably_
     * called from aslexrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void aslex_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		aslex_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void aslexpush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	aslexensure_buffer_stack();

	/* This block is copied from aslex_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from aslex_switch_to_buffer. */
	aslex_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void aslexpop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	aslex_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		aslex_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void aslexensure_buffer_stack (void)
{
	int num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)aslexalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)aslexrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE aslex_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) aslexalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in aslex_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	aslex_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to aslexlex() will
 * scan from a @e copy of @a str.
 * @param str a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       aslex_scan_bytes() instead.
 */
YY_BUFFER_STATE aslex_scan_string (yyconst char * str )
{
    
	return aslex_scan_bytes(str,strlen(str) );
}

/** Setup the input buffer state to scan the given bytes. The next call to aslexlex() will
 * scan from a @e copy of @a bytes.
 * @param bytes the byte buffer to scan
 * @param len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE aslex_scan_bytes  (yyconst char * bytes, int  len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = len + 2;
	buf = (char *) aslexalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in aslex_scan_bytes()" );

	for ( i = 0; i < len; ++i )
		buf[i] = bytes[i];

	buf[len] = buf[len+1] = YY_END_OF_BUFFER_CHAR;

	b = aslex_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in aslex_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up aslextext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		aslextext[aslexleng] = (yy_hold_char); \
		(yy_c_buf_p) = aslextext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		aslexleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int aslexget_lineno  (void)
{
        
    return aslexlineno;
}

/** Get the input stream.
 * 
 */
FILE *aslexget_in  (void)
{
        return aslexin;
}

/** Get the output stream.
 * 
 */
FILE *aslexget_out  (void)
{
        return aslexout;
}

/** Get the length of the current token.
 * 
 */
int aslexget_leng  (void)
{
        return aslexleng;
}

/** Get the current token.
 * 
 */

char *aslexget_text  (void)
{
        return aslextext;
}

/** Set the current line number.
 * @param line_number
 * 
 */
void aslexset_lineno (int  line_number )
{
    
    aslexlineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see aslex_switch_to_buffer
 */
void aslexset_in (FILE *  in_str )
{
        aslexin = in_str ;
}

void aslexset_out (FILE *  out_str )
{
        aslexout = out_str ;
}

int aslexget_debug  (void)
{
        return aslex_flex_debug;
}

void aslexset_debug (int  bdebug )
{
        aslex_flex_debug = bdebug ;
}

/* aslexlex_destroy is for both reentrant and non-reentrant scanners. */
int aslexlex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		aslex_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		aslexpop_buffer_state();
	}

	/* Destroy the stack itself. */
	aslexfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	register int i;
    	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	register int n;
    	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *aslexalloc (yy_size_t  size )
{
	return (void *) malloc( size );
}

void *aslexrealloc  (void * ptr, yy_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void aslexfree (void * ptr )
{
	free( (char *) ptr );	/* see aslexrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#undef YY_NEW_FILE
#undef YY_FLUSH_BUFFER
#undef yy_set_bol
#undef yy_new_buffer
#undef yy_set_interactive
#undef yytext_ptr
#undef YY_DO_BEFORE_ACTION

#ifdef YY_DECL_IS_OURS
#undef YY_DECL_IS_OURS
#undef YY_DECL
#endif
#line 171 "aslex.l"








int aslexwrap()
{
	return 1;
}


void yyerror(char *strp)
{
	fprintf(stderr,"error @ line %d: %s\n",
		yyloc.first_line,
		strp);
	exit(1);
}


static char *tok_to_str(int tok)
{
	static char buf[2];
	char * s;

	if (tok<256) {
		buf[0]=tok;
		buf[1]='\0';
		return (char*)buf;
	}
#define T(_t)	case _t : s = #_t; break;
	switch(tok) {
	T(T_nl);
	T(T_name);
	T(T_labeldef);
	T(T_register);
	T(T_number);
	T(T_string);
	T(T_load);
	T(T_store);
	T(T_cas);
	default: s = "unknown";
	}
#undef T
	return s;
}

token_t get_token()
{
	token_t tok;

	tok = aslexlex();

DBG(	printf("Line %d : token %d : %s",
		yyloc.first_line, tok, tok_to_str(tok));
	switch(tok) {
	case T_eof:	printf("END OF FILE"); break;
	case T_name:	printf(" : %s", yylval.namep);	break;
	case T_labeldef:	printf(" : %s", yylval.namep);	break;
	case T_register:	printf(" : %s", yylval.namep);	break;
	case T_number:	printf(" : 0x%llx", yylval.val);	break;
	case T_cas:
	case T_store:
	case T_load:	printf(" : %s : bytes=%d",
			yylval.ldst.signext ? "s" : "u", yylval.ldst.wordsize);
		break;
	default:
		break;
	}
	printf("\n");
	);

	return tok;
}


void free_yyval(token_t tok)
{
	switch (tok) {
	case T_name:
	case T_labeldef:
	case T_register:
		free(yylval.namep);
		yylval.namep = NULL;
		break;
	default:
		break;
	}
}


	/*
	 * Ultra simple parser to pull out only load or store instructions
	 * that fit a very basic template.
	 */

void lex_only()
{
	token_t tok, ldsttok, tok_left, tok_right;
	char	*tok_left_ptr, *tok_right_ptr;
	ldst_t	ldstinfo;

	while ((tok = get_token())!=T_eof) {
DBG(		printf("Start line with token %d\n", tok); );
		if (tok == T_nl) {
			continue;
		}

		/*
		 * Look for a load or store at the beginning of a line.
		 * if not found - swallow the line and move to the next.
		 * A line may also be allowed to have an initial label def.
		 */
		if (tok == T_labeldef) {
			free_yyval(tok);
			tok = get_token();
			if (tok==T_eof) break;
			if (tok == T_nl) continue;
		}

DBG(		printf("look for memop %d\n", tok); );

		tok_left = -1;
		tok_right = -1;
		tok_left_ptr = NULL;
		tok_right_ptr = NULL;

		if (tok != T_load && tok != T_store) goto swallow;

		ldsttok = tok;
		ldstinfo = yylval.ldst;

		if (tok == T_store) goto handle_store;
DBG(		printf("Handle load\n"); );

		tok = get_token();
		if (tok != '[') goto swallow;

		tok = get_token();
		if (tok != T_register && tok != T_name && tok != T_number) goto swallow;
		tok_left = tok;
		tok_left_ptr = yylval.namep;

			/* only want a + b forms */
		tok = get_token();
		if (tok != '+') goto cleanup;

		tok = get_token();
		if (tok != T_register && tok != T_name && tok != T_number) goto cleanup;
		tok_right = tok;
		tok_right_ptr = yylval.namep;

		tok = get_token();
		if (tok != ']') goto cleanup;

DBG(		printf("Load accepted\n"); );

		goto sanity_check;




handle_store:;
DBG(		printf("Handle store\n"););

		tok = get_token();
		if (tok != T_register) goto swallow;

		tok = get_token();
		if (tok != ',') goto swallow;

		tok = get_token();
		if (tok != '[') goto swallow;

		tok = get_token();
		if (tok != T_register && tok != T_name && tok != T_number) goto swallow;
		tok_left = tok;
		tok_left_ptr = yylval.namep;

			/* only want a + b forms */
		tok = get_token();
		if (tok != '+') goto cleanup;

		tok = get_token();
		if (tok != T_register && tok != T_name && tok != T_number) goto cleanup;
		tok_right = tok;
		tok_right_ptr = yylval.namep;

		tok = get_token();
		if (tok != ']') goto cleanup;

DBG(		printf("Store accepted\n"); );

		goto sanity_check;



	/*
	 * Finally the check we care about ...
	 */

sanity_check:;
	/*
	 * The load/store operands can be given in any order -
	 * register + offset or offset + register ... so to make things easier
	 * if we find one form we swap the paramaters to give us the other.
	 */

	/* one side must have a name for us to check */

	if (tok_left != T_name && tok_right != T_name) goto cleanup;

	/*
	 * if both sides are a name - we bail since there is likely more than one type
	 * for us to have to sanity check .. i.e. %g3 + BASE_OFSET + FOOBAR
	 */
	if (tok_left == T_name && tok_right == T_name) goto cleanup;

	/* now for the switch over */

	if (tok_left == T_name) {
		token_t temptok;
		char *tempptr;

		temptok = tok_left;
		tempptr = tok_left_ptr;
		tok_left = tok_right;
		tok_left_ptr = tok_right_ptr;
		tok_right = temptok;
		tok_right_ptr = tempptr;
	}
	
	/* finally something we can validate ... */

DBG(	printf("Validation of name %s\n", tok_right_ptr); );

	validate_op(ldsttok, &ldstinfo, tok_right_ptr);

	goto cleanup;


cleanup:;
		if (tok_left == T_name || tok_left == T_register) {
			free(tok_left_ptr);
		}
		if (tok_left == T_name || tok_left == T_register) {
			free(tok_left_ptr);
		}
		goto swallow;

swallow_loop:;
		tok = get_token();
		if (tok==T_eof) break;
swallow:;
		free_yyval(tok);
		if (tok!=T_nl) goto swallow_loop;
	}
}




void validate_op(token_t ldsttok, ldst_t *ldstinfop, char *namep)
{
	symbol_t *symp;

	symp = hash_find(namep);
	if (symp == NULL) {
		if (!flag_suppress_unknowns) {
			fprintf(stderr,"%s:%d : Warning: unknown symbol \'%s\' for memop\n",
				yyloc.fnamep, yyloc.first_line, namep);
			warning_count++;
		}
		return;
	}

		/* Compare sizes */
	if (symp->size != ldstinfop->wordsize) {
		fprintf(stderr,"%s:%d : Warning: access size mismatch using symbol \'%s\'\n",
			yyloc.fnamep, yyloc.first_line, namep);
		fprintf(stderr,"\tAccess uses %d byte memop, but should be a %d byte memop\n",
			ldstinfop->wordsize, symp->size);
		warning_count++;
	}

		/* if its a load compare sign extension */

	if (ldsttok == T_load) {
		if (ldstinfop->signext && ((symp->flags & Sym_unsigned)!=0)) {
			fprintf(stderr,"%s:%d : Warning: sign extension mismatch for symbol \'%s\'\n",
				yyloc.fnamep, yyloc.first_line, namep);
			fprintf(stderr,"\tAccess uses signed memop, but should be unsigned\n");
			warning_count++;
		} else
		if (!ldstinfop->signext && ((symp->flags & Sym_signed)!=0)) {
			fprintf(stderr,"%s:%d : Warning: sign extension mismatch for symbol \'%s\'\n",
				yyloc.fnamep, yyloc.first_line, namep);
			fprintf(stderr,"\tAccess uses unsigned memop, but should be signed\n");
			warning_count++;
		}
	}
}

