/*
* ========== Copyright Header Begin ==========================================
* 
* OpenSPARC T2 Processor File: device.h
* Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
* 
* The above named program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License version 2 as published by the Free Software Foundation.
* 
* The above named program is distributed in the hope that it will be 
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this work; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
* 
* ========== Copyright Header End ============================================
*/
/*
 * Copyright 2005 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

#ifndef	_DEVICE_H_
#define	_DEVICE_H_

#pragma ident	"@(#)device.h	1.3	05/10/05 SMI"

/*
 * This file contains function prototypes and data structures
 * for device generic support
 */

#ifdef __cplusplus
extern "C" {
#endif

#ifndef NDEBUG /* { */
#define DBG_DEV         0x80000000LL
#define DBGDEV(s)       do { if (debug_bits & DBG_DEV) { s } } while (0)        /* debug device */
#else /* } { */
#define DBGDEV(_s)      do { } while (0)
#endif /* } */

/*
 * For devices that have no cacheable address space areas
 * use this function instead of declaring it for every device.
 */
tpaddr_t generic_device_non_cacheable(
        config_addr_t *  config_addrp,
        dev_access_t    type,
        tpaddr_t        offset,
        uint8_t **      blockp);

#ifdef __cplusplus
}
#endif

#endif	/* #ifndef	_DEVICE_H_ */
