/*
* ========== Copyright Header Begin ==========================================
* 
* OpenSPARC T2 Processor File: createthr.c
* Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
* 
* The above named program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License version 2 as published by the Free Software Foundation.
* 
* The above named program is distributed in the hope that it will be 
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this work; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
* 
* ========== Copyright Header End ============================================
*/
#include <sys/types.h>
#include <sys/socket.h>
#include <errno.h>
#include <pthread.h>
#include <stdlib.h>

#include "basics.h"
#include "fatal.h"
#include "createthr.h"

void create_thread(void *(*start_funcp)(void *), void * argp, pthread_t * idp)
{
	int res;
		/* create the execution thread */

	do {
		pthread_attr_t attr;
		pthread_attr_init(&attr); /* initialize attr with default attributes */
		pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);	/* schedule like a process */
		res = pthread_create( idp, &attr, start_funcp, argp );
		pthread_attr_destroy(&attr);
	} while (res == -1 && errno == EAGAIN);
	if (res == -1) fatal("failed to create thread");
}

