/*
* ========== Copyright Header Begin ==========================================
* 
* OpenSPARC T2 Processor File: fileutil.c
* Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
* 
* The above named program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License version 2 as published by the Free Software Foundation.
* 
* The above named program is distributed in the hope that it will be 
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this work; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
* 
* ========== Copyright Header End ============================================
*/
/*
 * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

#pragma ident	"@(#)fileutil.c	1.6	06/07/20 SMI"

#include <stdio.h>
#include <stdarg.h>
#include <unistd.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "basics.h"
#include "fatal.h"

FILE *
fopen_check(char * fnamep, char * optsp)
{
	FILE * fp;

	fp = fopen(fnamep, optsp);
	if (fp == NULL)
		fatal("failed opening %s", fnamep);
	return fp;
}


bool_t
file_exists(char * fnamep)
{
	struct stat sb;
	int res;

	do {
		res = stat(fnamep, &sb);
	} while (res == -1 && errno == EAGAIN);

	return (res == 0);
}


bool_t
is_a_dir(char * dirnamep)
{
	struct stat sb;

	if (dirnamep == NULL)
		return false;

	if (stat(dirnamep, &sb) < 0)
		return false;

	return S_ISDIR(sb.st_mode);
}
