/*
* ========== Copyright Header Begin ==========================================
* 
* OpenSPARC T2 Processor File: barrier.h
* Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
* 
* The above named program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License version 2 as published by the Free Software Foundation.
* 
* The above named program is distributed in the hope that it will be 
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this work; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
* 
* ========== Copyright Header End ============================================
*/
/*
 * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

#ifndef _BARRIER_H
#define	_BARRIER_H

#pragma ident	"@(#)barrier.h	1.2	06/08/08 SMI"

#ifdef __cplusplus
extern "C" {
#endif

#include <thread.h>
#include "basics.h"

typedef struct {
	int maxcnt;		/* maximum number of runners */
	struct _sb {
		cond_t wait_cv; /* cv for waiters at barrier */
		mutex_t wait_lk; /* mutex for waiters at barrier */
		int runners;	/* number of running threads */
	} sb[2];
	struct _sb   *sbp;	/* current sub-barrier */
} barrier_t;

extern int barrier_init(barrier_t *bp, int count);
extern void barrier_wait(barrier_t *bp);

typedef struct {
	int maxcnt;		/* maximum number of runners */
	struct _sbb {
		volatile int spin_cv;	/* "cv" for waiters at barrier */
		volatile int runners;	/* number of running threads */
	} sbb[2];
	struct _sbb   *sbbp;	/* current sub-busy-barrier */
} barrier_busy_t;

extern int barrier_busy_init(barrier_busy_t *bbp, int count);
extern void barrier_busy_wait(barrier_busy_t *bbp);

#ifdef __cplusplus
}
#endif

#endif /* _BARRIER_H */
