/*
* ========== Copyright Header Begin ==========================================
* 
* OpenSPARC T2 Processor File: roundup.c
* Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
* 
* The above named program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License version 2 as published by the Free Software Foundation.
* 
* The above named program is distributed in the hope that it will be 
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this work; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
* 
* ========== Copyright Header End ============================================
*/
#include <sys/types.h>

#include "basics.h"

uint64_t sim_roundup(uint64_t value, uint64_t round)
{
	if (round==0) return 0;

		/* if not a power of two rounding use the slow integer math method */
	if (round & (round-1)) {
		uint64_t temp;

		temp = value + round;
		temp -= temp % round;
		value = temp;
	} else {
		value = (value + round -1) & ~(round -1);
	}

	return value;
}
