/*
* ========== Copyright Header Begin ==========================================
* 
* OpenSPARC T2 Processor File: strutil.c
* Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
* 
* The above named program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License version 2 as published by the Free Software Foundation.
* 
* The above named program is distributed in the hope that it will be 
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this work; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
* 
* ========== Copyright Header End ============================================
*/
#include <sys/types.h>
#include <string.h>
#include <strings.h>

#include "basics.h"
#include "strutil.h"

bool_t streq (char* a, char* b)
{
	return (strcmp(a, b) == 0);
}

    /* returns true if two strings A and B match, ignoring case*/
bool_t streqi (char* a, char* b)
{
	return (strcasecmp(a, b) == 0);
}

    /* true if STR starts with PREFIX*/
bool_t strprefix(char* str, char* prefix)
{
	int plen = strlen(prefix);
	return (strncmp(str, prefix, plen) == 0);
}

    /* true if STR ends with SUFFIX*/
bool_t strsuffix (char* str, char* suffix)
{
	int slen = strlen(suffix);
	int l = strlen(str);
	if (slen > l) {
		return 0;
	} else {
		return (strncmp( &str[l-slen], suffix, slen) == 0);
	}
}


