/*
* ========== Copyright Header Begin ==========================================
* 
* OpenSPARC T2 Processor File: vfatal.c
* Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
* 
* The above named program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License version 2 as published by the Free Software Foundation.
* 
* The above named program is distributed in the hope that it will be 
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this work; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
* 
* ========== Copyright Header End ============================================
*/
/*
 * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

#pragma ident	"@(#)vfatal.c	1.7	06/04/26 SMI"

#include <stdarg.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

#include "basics.h"
#include "fatal.h"


void vfatal(bool_t really_quit, char * fmt, va_list args)
{
	char * quit = really_quit ? "fatal" : "warning";

	if (errno != 0) {
		fprintf(stderr,"%s error: %s : ",quit,strerror(errno));
	} else {
		fprintf(stderr,"%s: ",quit);
	}
	vfprintf(stderr,fmt,args);
	fprintf(stderr,"\n");

	if (really_quit) exit(1);
}
