# ========== Copyright Header Begin ==========================================
# 
# OpenSPARC T2 Processor File: Makefile.inc
# Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
# 
# The above named program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation.
# 
# The above named program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public
# License along with this work; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
# 
# ========== Copyright Header End ============================================
#
# Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
#	ident	"@(#)Makefile.inc	1.9	07/01/18 SMI"
#
# Makefile for processor directory
#
# This is dumb for now ... eventually each processor type
# will be a dl module into the simulator. Thus it will be complied
# and installed independently of the core simulator.
# For now though since we've only one processor to deal with
# we'll statically compile it in just like everything else
# so I can avoid having to write all the DL support code.
#
# FIXME
#

HOSTSRCS=\
	hostnative_asm.S

HOSTOBJS=\
	hostnative_asm.o

MADESRCS+=assembly.h hostnative_asm.s hostnative.h hostnative_ua200x.h

OBJS+=$(HOSTOBJS)

assembly.h : asmgen
	echo "#ifndef	_ASSEMBLY_H_" > $@
	echo "#define	_ASSEMBLY_H_" >> $@
	echo "" >> $@
	./asmgen >> $@
	echo "" >> $@
	echo "#endif	/* _ASSEMBLY_H_ */" >> $@

.INTERMEDIATE: hostnative_asm.s

hostnative_asm.s : assembly.h

sparcv9decode.o : hostnative.h

hostnative.h : hostnative.c
	./hasnative $< $@

ifdef BUILDFPSIM
hostnative_ua200x.h : hostnative_ua200x.c
	./hasnative $< $@
else
hostnative_ua200x.h :
	touch $@
endif
