/*
* ========== Copyright Header Begin ==========================================
* 
* OpenSPARC T2 Processor File: i686.h
* Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
* 
* The above named program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License version 2 as published by the Free Software Foundation.
* 
* The above named program is distributed in the hope that it will be 
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this work; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
* 
* ========== Copyright Header End ============================================
*/
/*
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

#ifndef	_I686_H_
#define	_I686_H_

#pragma ident	"@(#)i686.h	1.2	07/01/18 SMI"

#ifdef	__cplusplus
extern "C" {
#endif

#include <sys/types.h>

#if HOST_OS_SOLARIS9		/* { */
#include <sys/int_types.h>
#elif HOST_OS_LINUX		/* } { */
#include <stdint.h>
#endif				/* } */

#define	HOST_CPU_LITTLE_ENDIAN	1

#define	FE_INSTN(_instn) \
		((_instn>>24) | ((_instn>>8)&0xff00) | \
		((_instn & 0xff00)<<8) | ((_instn&0xff)<<24))


	/*
	 * define non-ANSI names for signed integer types
	 * - do this explicitly because I can never remember
	 * that int32_t is signed ! so cast it to a sint32_t instead !
	 */

typedef	int8_t	sint8_t;
typedef	int16_t	sint16_t;
typedef	int32_t sint32_t;
typedef int64_t	sint64_t;

typedef enum { false=0, true=!false } bool_t;

typedef	uint32_t	ieee_fp32_t;
typedef	uint64_t	ieee_fp64_t;
typedef	long double	ieee_fp128_t;

#ifdef	__cplusplus
}
#endif

#endif	/* _I686_H_ */
