# ========== Copyright Header Begin ==========================================
# 
# OpenSPARC T2 Processor File: Makefile.inc
# Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
# 
# The above named program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation.
# 
# The above named program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public
# License along with this work; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
# 
# ========== Copyright Header End ============================================
#
# Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# parser subdirectory Makefile
#
#	ident	"@(#)Makefile.inc	1.7	06/03/22 SMI"
#


PARSRCS = parser.c dumpconfig.c initconfig.c

LEXOBJ= lexer.o
#PAROBJS = $(PARSRCS:%.c=%.o) $(LEXOBJ)
PAROBJS = $(LEXOBJ) $(PARSRCS:%.c=%.o)

MADESRCS+=lexer.c

OBJS+=$(PAROBJS)
PARCFLAGS=$(CFLAGS) -I$(SRCDIR)/devices/mmi

parser.o : parser.c
	$(CC) $(PARCFLAGS) $(CPPFLAGS) -c -o $@ $^

LEXER_SUPPRESSED_ERRORS=-erroff=E_STATEMENT_NOT_REACHED

lexer.o : lexer.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(LEXER_SUPPRESSED_ERRORS) -c -o $@  $^

lexer.c : lexer.l
	$(LEX) -Plex $(LFLAGS) -o$@ $^

lexer: lexer.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -o lexer $^ -DTESTRIG=1

