/*
* ========== Copyright Header Begin ==========================================
* 
* OpenSPARC T2 Processor File: lexer.h
* Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
* 
* The above named program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License version 2 as published by the Free Software Foundation.
* 
* The above named program is distributed in the hope that it will be 
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this work; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
* 
* ========== Copyright Header End ============================================
*/
/*
 * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
#pragma ident	"@(#)lexer.h	1.7	06/10/06 SMI"

#ifndef	_LEXER_TOKENS_H_
#define	_LEXER_TOKENS_H_

#ifdef	__cplusplus
extern "C" {
#endif

typedef enum {
	T_EOF,
	T_L_Brace,
	T_R_Brace,
	T_S_Colon,
	T_Plus,
	T_Minus,
	T_Comma,
	T_Number,
	T_HexString,
	T_String,
	T_Token,
	T_Amp,
	T_Error
} lexer_tok_t;

typedef struct {
	int		linenum;
	char *		fnamep;
	char *		cleanup_filep;
	uint64_t	val;
	char *		strp;
	bool_t		ungot_available;
	lexer_tok_t	last_token;
} lexer_t;

extern lexer_t lex;

void init_lexer(char * fnamep, FILE * fp, char * cleanup_filep);
lexer_tok_t lex_get_token();
void lex_get(lexer_tok_t expected);
void lex_unget();
void lex_fatal(char * s, ...);


#ifdef	__cplusplus
}
#endif

#endif	/* _LEXER_TOKENS_H_ */
