# ========== Copyright Header Begin ==========================================
# 
# OpenSPARC T2 Processor File: Makefile.inc
# Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
# 
# The above named program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation.
# 
# The above named program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public
# License along with this work; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
# 
# ========== Copyright Header End ============================================
#
# Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# ident	"@(#)Makefile.inc	1.14	07/10/12 SMI"
#
# sparcv9 core files makefile
#

PROCSRCS=\
	sparcv9regs.c	\
	sparcv9cc.c	\
	sparcv9decode.c	\
	sparcv9core.c	\
	sparcv9instns.c \
	hostnative.c \
	magictraps.c

ifdef INTERNAL_BUILD
PROCSRCS+=\
	sparcv9dis.c \
	sparcv9dis_tbl.c
endif


PROCOBJS=$(PROCSRCS:%.c=%.o)

MADESRCS+=sparcv9regs.c sparcv9regs.h reggen reggen.c \
	sparcv9instns.h sparcv9cc.c sparcv9cc.h	\
	hostnative_asm.h

TEST=foo

OBJS+=$(PROCOBJS)

.INTERMEDIATE: sparcv9regs.c

.INTERMEDIATE: sparcv9regs.h

sparcv9regs.c sparcv9regs.h : reggen

sparcv9regs.c sparcv9regs.h : sparcv9regs.spec
	./reggen sparcv9regs "sparcv9" < $<


#
# Auto generated dependencies
#

sparcv9cc.c :
	./sparcccgen sparcv9cc sparcv9_cc_magic

sparcv9core.o sparcv9instns.o : sparcv9regs.h

sparcv9instns.o sparcv9decode.o : sparcv9instns.h

sparcv9decode.o : hostnative_asm.h

sparcv9instns.h : sparcv9instns.c
	./implhdr $< decoded_impl_sparcv9_ $@

hostnative_asm.s : hostnative_asm.S

hostnative_asm.h : hostnative_asm.S
	./hasnative $< $@
