# ========== Copyright Header Begin ==========================================
# 
# OpenSPARC T2 Processor File: Makefile.inc
# Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
# 
# The above named program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation.
# 
# The above named program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public
# License along with this work; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
# 
# ========== Copyright Header End ============================================
#
# Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# ident	"@(#)Makefile.inc	1.6	06/10/06 SMI"
#
# debug tools makefile
#


DEBUG_VER=.1

COVERAGE_SRC=coverage_dump.c
COVERAGE_BIN=coverage_dump
COVERAGE_OBJ=coverage_dump.o
COVERAGE_PL_BIN=coverage.pl
COVERAGE_PL_SRC=$(SRCDIR)/procs/sunsparc/debug/tools/$(COVERAGE_PL_BIN)

MADEBINS+=$(COVERAGE_BIN) $(COVERAGE_PL_BIN)

# Need the following object files for certain functions to work
COVERAGE_DEP=coverage_dump.o sparcv9dis.o fatal.o vfatal.o sparcv9dis_tbl.o


DEBUG_INCLUDES=-I$(SRCDIR)/procs/sunsparc/include
DEBUG_CFLAGS=$(DEBUG_INCLUDES) $(CFLAGS) -DDEBUG1

LIBS+=\
	$(COVERAGE_BIN) $(COVERAGE_PL_BIN)

$(COVERAGE_OBJ) : $(COVERAGE_SRC)
	$(CC) $(DEBUG_CFLAGS) $(CPPFLAGS) -c -o $@ $^

$(COVERAGE_PL_BIN) : FRC
	@echo "================> Making $(COVERAGE_PL_BIN)"
	@cp $(COVERAGE_PL_SRC) $(COVERAGE_PL_BIN)
	@chmod a+wx $(COVERAGE_PL_BIN)

$(COVERAGE_BIN) : $(COVERAGE_OBJ)
	@echo "================> Making $(COVERAGE_BIN)"
	$(CC) $(DEBUG_CFLAGS) $(CPPFLAGS) -o $(COVERAGE_BIN) $(COVERAGE_DEP)
	
