/*
* ========== Copyright Header Begin ==========================================
* 
* OpenSPARC T2 Processor File: modarith_types.h
* Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
* 
* The above named program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License version 2 as published by the Free Software Foundation.
* 
* The above named program is distributed in the hope that it will be 
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this work; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
* 
* ========== Copyright Header End ============================================
*/
/*
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

#ifndef _MODARITH_TYPES_H
#define	_MODARITH_TYPES_H

#pragma ident	"@(#)modarith_types.h	1.2	07/02/19 SMI"

#ifdef	__cplusplus
extern "C" {
#endif

#define	MA_MEM_XWORDS	160
#define	MA_N_ADDR	6

typedef struct MODARITH {
	/* PERRINJ not implemented */
	unsigned char	strand;      /* two bit integer */
	unsigned char	busy;
	unsigned char	do_interrupt;         
	unsigned char	op;
	unsigned char	length;      /* true length (field + 1) */
	uint64_t	ma_data_p;   /* physaddr for load and store */
	unsigned char	ADDR[MA_N_ADDR];     /* offsets into MA memory */
	uint64_t	n_prime;     /* for Montgomery multiplication */
	uint64_t       	ma_mem[MA_MEM_XWORDS]; /* 1280 bytes of MA memory */
	pthread_mutex_t	lock;
} mod_arith_t;



typedef enum {
	MOD_ARITH_DONE,
	MOD_ARITH_LD_COMPLETE,
	MOD_ARITH_DATA_ACCESS_EX_TRAP,
	MOD_ARITH_MEM_ALIGN_TRAP,
	MOD_ARITH_ILLEGAL_INST_TRAP,
	MOD_ARITH_FATAL,
	MOD_ARITH_UNIMPLEMENTED
} mod_arith_rv_t;

#ifdef	__cplusplus
}
#endif

#endif /* _MODARITH_TYPES_H */
