/*
* ========== Copyright Header Begin ==========================================
* 
* OpenSPARC T2 Processor File: niagara_err_trap.c
* Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
* DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
* 
* The above named program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License version 2 as published by the Free Software Foundation.
* 
* The above named program is distributed in the hope that it will be 
* useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
* 
* You should have received a copy of the GNU General Public
* License along with this work; if not, write to the Free Software
* Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
* 
* ========== Copyright Header End ============================================
*/
/*
 * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */
#pragma ident	"@(#)niagara_err_trap.c	1.4	06/08/11 SMI"


#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>	/* memcpy/memset */
#include <strings.h>
#include <thread.h>

#include "basics.h"
#include "fatal.h"
#include "allocate.h"
#include "strutil.h"
#include "lexer.h"
#include "simcore.h"
#include "config.h"
#include "tsparcv9.h"
#include "tsparcv9internal.h"



/*
 * Error trap generation not supported on Niagara. Do Nothing.
 */
void ss_error_trap_proc_init(config_proc_t * config_procp) {
	FIXME_WARNING(("Error trap generation not supported on Niagara\n"));
	return;
}
void ss_error_trap_strand_init(config_proc_t * config_procp, simcpu_t * sp) {
	FIXME_WARNING(("Error trap generation not supported on Niagara\n"));
	return;
}
void ss_check_error_traps(simcpu_t * sp) {
	FIXME_WARNING(("Error trap generation not supported on Niagara\n"));
	return;
}
void ss_error_taking_trap( simcpu_t * sp, sparcv9_trap_type_t trap_type ) {
	FIXME_WARNING(("Error trap generation not supported on Niagara\n"));
	return;
}
void ss_error_asi_parse(void * procp, bool_t is_reload) {
	FIXME_WARNING(("Error trap generation not supported on Niagara\n"));
	return;
}
void ss_error_event_parse(void * procp, bool_t is_reload) {
	FIXME_WARNING(("Error trap generation not supported on Niagara\n"));
	return;
}
bool_t trigger_error_trap(simcpu_t * sp) {
	FIXME_WARNING(("Error trap generation not supported on Niagara\n"));
	return false;
}
void ss_error_reload_file(config_proc_t * procp) {
	FIXME_WARNING(("Error trap generation not supported on Niagara\n"));
	return;
}
void ss_error_parse_filename(void * procp) {
	FIXME_WARNING(("Error trap generation not supported on Niagara\n"));
	return;
}
void ss_error_dump_active(void * procp) {
	FIXME_WARNING(("Error trap generation not supported on Niagara\n"));
	return;
}
void ss_error_dump_supported(void * procp) {
	FIXME_WARNING(("Error trap generation not supported on Niagara\n"));
	return;
}
bool_t n1_sp_interrupt(simcpu_t * sp, uint64_t intr_level, char * error_name) {
	FIXME_WARNING(("Error trap generation not supported on Niagara\n" \
			  "\terror name = %s, intr_level = %d\n",
			  error_name, intr_level));
	return false;
}
