# ========== Copyright Header Begin ==========================================
# 
# OpenSPARC T2 Processor File: Makefile.inc
# Copyright (c) 2006 Sun Microsystems, Inc.  All Rights Reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES.
# 
# The above named program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public
# License version 2 as published by the Free Software Foundation.
# 
# The above named program is distributed in the hope that it will be 
# useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
# 
# You should have received a copy of the GNU General Public
# License along with this work; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.
# 
# ========== Copyright Header End ============================================
#
# Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
# Use is subject to license terms.
#
# Simulator core makefile
#
#	ident	"@(#)Makefile.inc	1.12	06/10/25 SMI"
#

COREINSTNS=execinstns.c
ifdef REMOVEMACROS
CCCOREINSTNS=dem-execinstns.c
MADESRCS+=$(CCCOREINSTNS)
else
CCCOREINSTNS=execinstns.c
endif

INSTNIMPL+=$(CCCOREINSTNS)

CORESRCS=\
	main.c		\
	signals.c	\
	control.c	\
	options.c	\
	dbgrif.c	\
	xicache.c	\
	xdcache.c	\
	execkern.c	\
	breakpoint.c	\
	callback.c	\
	$(CCCOREINSTNS)

MADESRCS+=execinstns.h

COREOBJS=$(CORESRCS:%.c=%.o) execkern_dh.o

OBJS+=$(COREOBJS)

execinstns.h : $(COREINSTNS)
	./implhdr $< decoded_impl_ $@


EXECKERN_SUPPRESSED_ERRORS=-erroff=E_LOOP_NOT_ENTERED_AT_TOP

execkern.o : execkern.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(EXECKERN_SUPPRESSED_ERRORS) -c -o $@ $^

execkern_dh.o : execkern.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(EXECKERN_SUPPRESSED_ERRORS) -DDEBUG_HOOK_LOOP -c -o $@ $^

execinstns.o : execinstns.h

execinstns.o : execinstns.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@

dem-execinstns.c : execinstns.h

dem-execinstns.c : execinstns.c
	echo $(COREOBJS)
	$(CC) $(CFLAGS) $(CPPFLAGS) -E $< > /tmp/prep-$@
	code-tidy < /tmp/prep-$@ > $@
